"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var test_1 = require("@playwright/test");
var utils_1 = require("./utils");
/**
 * Create a testbed platform for quick tests
 */
function default_1(browsers, folder) {
    if (browsers === void 0) { browsers = [
        'Desktop Chrome',
        'Desktop Firefox',
        'Desktop Safari',
        'Desktop Edge',
        'Pixel 5',
        'iPhone 12'
    ]; }
    if (folder === void 0) { folder = 'testbed'; }
    var projects = [];
    for (var _i = 0, browsers_1 = browsers; _i < browsers_1.length; _i++) {
        var browser = browsers_1[_i];
        // What folders will it use tests from?
        var folders = [
            // A slugified version of it's name (e.g. iphone-12)
            (0, utils_1.slugify)(browser),
            // The browser type (e.g. webkit)
            test_1.devices[browser].defaultBrowserType,
            // A mobile or desktop folder
            (test_1.devices[browser].isMobile ? 'mobile' : 'desktop'),
        ]
            // Add an escaped slash at the end (for the Regex)
            // eslint-disable-next-line  no-useless-escape
            .map(function (f) { return f + '\/'; })
            // Join them with a pipe
            .join('|');
        projects.push({
            name: browser,
            use: __assign({}, test_1.devices[browser]),
            // Anything in tests
            testDir: './' + folder,
            // Match anything top level or anything in a type folder
            // eslint-disable-next-line  no-useless-escape
            testMatch: new RegExp(folder + '\/(' + folders + ')?[^\/]+.(spec|test).(c|m)?[jt]s(x)?')
        });
    }
    return projects;
}
exports.default = default_1;
